<template>
	<template v-if="definition && forms">
		<pre>{{ definition }}</pre>
		<FormField :definition="forms"></FormField>
	</template>
</template>

<script setup>
import { shallowRef, watchEffect } from "vue";
import { useRoute } from "vue-router";
import { parseFormDefinition } from "@/lib/main";
import FormField from "@/components/FormField.vue";

const route = useRoute();

const definition = shallowRef( null );

const forms = shallowRef( null );

watchEffect( async() => {
	if ( route.params.route ) {
		definition.value = await import( `../../examples/${route.params.route}/example.json` )
			.then( module => module.default );
	} else {
		definition.value = null;
	}

	forms.value = ( await parseFormDefinition( definition.value, {
		context: {
			locale: "en"
		}
	} ) )();
} );
</script>

<style>
pre {
	flex: 1 0 40%;
	background: #f0f0f0;
	padding: 0.5em;
	font-size: 0.8em;
	line-height: 1.2;
	margin: 0 1em;
}

.form-field {
	flex: 1 0 40%;
}
</style>
